%define ALD_Ver		2.0

Name:         libaom

License:      BSD
Summary:      AV1 Codec Library
Version:      3.9.1
Release:      0

# https://aomedia.googlesource.com/aom/+/refs/tags/v3.9.1

Source: %{name}-%{version}.tar.xz

%define DestDir		/Multimedia
# -----------------------------------------------------

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}
%define _CROSS 0
%define MakeLocCross 0
%else
# rpm --target=armv7hl -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%define MakeLocCross 1
%define _host %{_arch}-%{_os}%{_gnu}
%endif

#------------------ CROSS DIR --------------------

%define docdir		%{_defaultdocdir}/%{name}

%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%if %{have_auto_local}
%define __os_install_post %{nil}
%define CrossPath	%(%{auto_local} -GetCrossPath -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu})
%endif

# ------------------- description ------------------------------------
%description
AV1 Codec Library
#-------------------------------
%package tools
Summary:      The aom command line tools
%description tools
The aom command line tools
#-------------------------------
%package devel
Summary:      Libraries for the C compiler
%description devel
These libraries are needed to compile C code.

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}

# ------------------- Build ------------------------------------------
%Build 
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

%if %{_arch} == "i386"
OPTFLAGS="-O2 -march=i586 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-O2"
%endif
%if %{_arch} == "arm"
OPTFLAGS="%{optflags} -O2 -munaligned-access"
%endif

OPTFLAGS="$OPTFLAGS -fno-asynchronous-unwind-tables -ffunction-sections -fdata-sections"

CFLAGS="$OPTFLAGS"
LDFLAGS="-Wl,--gc-sections"

export CFLAGS LDFLAGS

rm -rf _Build
mkdir _Build

pushd _Build

cmake \
  -D CMAKE_INSTALL_PREFIX=%{_prefix} \
  -D CMAKE_INSTALL_SYSCONFDIR=/etc \
  -D CMAKE_INSTALL_LIBDIR=%{_libdir} \
  -D CMAKE_BUILD_TYPE=Release \
  -D CMAKE_VERBOSE_MAKEFILE=ON \
  -D CMAKE_SKIP_RPATH=1 \
  -D BUILD_SHARED_LIBS=1 \
  -D ENABLE_TESTS=0 \
  -D ENABLE_SSE4_1=OFF \
  -D ENABLE_SSE4_2=OFF \
  -D ENABLE_SSSE3=OFF \
  -D ENABLE_SVE=OFF \
  -D ENABLE_SVE2=OFF \
   .. &>FConfigure_log.txt

make &>FMake_log.txt

popd

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

cd _Build
make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt
cd ..

cp -a LICENSE $RPM_BUILD_ROOT%{docdir}/
rm $RPM_BUILD_ROOT%{_libdir}/libaom.a

/usr/lib/rpm/check-rpaths

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} -DelLocCrossDir=%{_bindir}
%endif  # have_auto_local

# ------------------- Clean ------------------------------------------
%Clean

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# ------------------- Files ------------------------------------------
%files
%{_libdir}/*.so.*
%{docdir}

%files tools
%{_bindir}

%files devel
%{_includedir}
%{_libdir}/pkgconfig
%{_libdir}/*.so

